{-|
Module      : Main.hs
Description : Gargantext central exchange for async notifications
Copyright   : (c) CNRS, 2017-Present
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

 -}

{-# LANGUAGE Strict            #-}

module Main where

import Control.Concurrent (threadDelay)
import Control.Monad (join, mapM_)
import Data.ByteString.Char8 qualified as C
import Data.Text qualified as T
import Gargantext.Prelude
import Nanomsg
import Options.Applicative


data Command =
    Server
  | Client

parser :: Parser (IO ())
parser = subparser
    ( command "server" (info (pure gServer) idm)
   <> command "client" (info (pure gClient) idm) )

   
main :: IO ()
main = join $ execParser (info parser idm)

gClient :: IO ()
gClient = do
    withSocket Push $ \s -> do
      _ <- connect s "tcp://localhost:5560"
      let str = C.unwords (take 1000 $ repeat "hello")
      C.putStrLn $ C.pack "sending: " <> (C.take 100 str)
      replicateM_ 100 $
        send s str
    
gServer :: IO ()
gServer = do
    withSocket Pull $ \s -> do
      _ <- bind s "tcp://*:5560"
      forever $ do
        putText "receiving"
        r <- recv s
        C.putStrLn $ C.take 100 r
        -- r <- recv' s
        -- -- putText $ T.pack $ C.unpack r
        -- putText "..."
        -- case r of
        --   Nothing -> pure ()
        --   Just r' -> C.putStrLn $ C.take 100 r'
        -- threadDelay 1000000
    -- withSocket Pub $ \s -> do
    --     _ <- bind s "tcp://*:5560"
    --     mapM_ (\num -> sendNumber s num) (cycle [1..1000000 :: Int])
    -- where
    --     sendNumber s number = do
    --         threadDelay 1000        -- let's conserve some cycles
    --         let numAsString = show number
    --         send s (C.pack numAsString)

